//
//  QXYClassDownloadHeader.h
//  KClassDownloadSDK
//
//  Created by 王博 on 2020/7/3.
//  Copyright © 2020 王博. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "KCDDownloadParams.h"
#import "QXCDownloadParseChatDataModel.h"

NS_ASSUME_NONNULL_BEGIN



/// 当前下载器只支持一个下载任务
@interface QXCClassDownloadHeader : NSObject


/// 获取下载器单例对象
+ (instancetype)getInstance;

/// 销毁单例对象
+ (void)destoryInstance;


/// 开始下载任务
/// @param params params
-(void)startDownloadClass:(KCDDownloadParams*)params;

/// 暂停下载任务
/// @param params params
-(void)pauseDownloadClass:(KCDDownloadParams*)params;

/// 删除下载任务,并删除本地已下载的文件
/// 如果当前任务正在下载,则从下载队列中移除
/// @param params params
-(void)deleteDownloadClass:(KCDDownloadParams*)params;

/// 获取当前已下载完成的大小
/// @param params params
-(NSUInteger)getFinishSizeByParams:(KCDDownloadParams*)params;

/// 判断是否下载完成;YES(下载完)
/// @param params params
-(BOOL)checkDownloadFinishByParams:(KCDDownloadParams*)params;

/// 设置下载器环境变量
/// @param serverType 1测试 2 线上
-(void)setServerType:(KDCServerType)serverType;


/// 获取当前下载器正在下载的 classID
-(NSString*)getCurrentDownloadClassId;

/// 获取下载任务已下载的详细信息
-(NSMutableDictionary*)getDownloadMediaInfo:(KCDDownloadParams*)params;

- (NSMutableDictionary *)getDownloadMediaConfigInfo:(NSString *)classId;

- (void)parserWBLocalPlaybackData:(NSString *)classId completed:(void (^)(NSArray *array))complete;

- (void)parseRoomLocalPlaybackData:(NSString *)classId completed:(void (^)(NSArray *array))complete;

- (void)parseChatLocalPlaybackData:(NSString *)classId completed:(void (^)(NSArray *array))complete;

- (void)parseMarkListClassId:(NSString *)classId completed:(void (^)(NSArray *array))complete;

- (void)parseUserMarkListClassId:(NSString *)classId completed:(void (^)(NSArray *array))complete;

- (NSMutableDictionary *)getDownloadMediaConfigData:(KCDDownloadParams *)params;



- (void)parseRoomLocalPlaybackDataWithModel:(KCDDownloadParams *)params completed:(void (^)(NSArray *array))complete;

- (void)parseChatLocalPlaybackDataWithModel:(KCDDownloadParams *)params completed:(void (^)(NSArray *array))complete;

- (void)parseMarkListWithModel:(KCDDownloadParams *)params completed:(void (^)(NSArray *array))complete;

- (void)parseUserMarkListWithModel:(KCDDownloadParams *)params completed:(void (^)(NSArray *array))complete;

- (void)parseAllChatLocalPlaybackDataWithModel:(KCDDownloadParams *)params completed:(void (^)(QXCDownloadParseChatDataModel *result))complete;

@end

NS_ASSUME_NONNULL_END
