//
//  QXCPlayBackSDKHeader.h
//  QXCClassSDK
//
//  Created by 王博 on 2020/7/2.
//  Copyright © 2020 k. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "QXCClassParams.h"
#import "QXCProductModel.h"

NS_ASSUME_NONNULL_BEGIN

@protocol QXCPlayBackSDKHeaderDelegate <NSObject>

-(void)closePlayBack;
-(void)userClickUrlByTopTipMsg:(NSString*)url;
-(void)userClickProduct:(NSDictionary*)dic;

-(void)alwaysAllowWWan:(BOOL)allow;

-(void)willEnterPicInPicPlayBack;
-(void)willResumePlayBackByPicInPic;
@end

@protocol QXCPlayBackSDKReportDelegate <NSObject>
//切换到音频:1  切换到视频:2
-(void)qxc_reportSwitchMediaType:(NSInteger)type params:(QXCClassParams*) params;
//播放点击：1 暂停点击：2
-(void)qxc_reportPlayStatus:(NSInteger)type params:(QXCClassParams*) params;
// 屏幕双击播放：1 暂停：2
-(void)qxc_reportScreenDoubleClick:(NSInteger) type params:(QXCClassParams*) params;
//快进15s：1  快退15s：2
-(void)qxc_reportForwardReverse:(NSInteger)type params:(QXCClassParams*) params;
// 倍速切换 0.8倍速：0.8；1倍速：1；1.5倍速：1.5
-(void)qxc_reportPlayRate:(CGFloat)rate params:(QXCClassParams*) params;
// 切换到横屏：1；切换到竖屏：2
-(void)qxc_reportSwitchFullScreen:(NSInteger)type params:(QXCClassParams*) params;
// 屏幕锁定：1；屏幕解锁：2
-(void)qxc_reportLocakScreen:(NSInteger)type params:(QXCClassParams*) params;
// 视频拖拽：beforeTime为拖拽之前的时间点，afterTime为拖拽后的时间点
-(void)qxc_reportSeek:(NSInteger) beforeTime afterTime:(NSInteger) afterTime params:(QXCClassParams*) params;
// 打开画中画：1；关闭画中画:2
-(void)qxc_reportEnterPickInPic:(NSInteger)type params:(QXCClassParams*) params;
// 开启后台播放：1；关闭后台播放：2
-(void)qxc_reportOpenPlayByBack:(NSInteger)type params:(QXCClassParams*) params;
@end


@interface QXCPlayBackSDKHeader : NSObject

@property (nonatomic,weak) id<QXCPlayBackSDKHeaderDelegate> delegate;
@property (nonatomic,weak) id<QXCPlayBackSDKReportDelegate> reportDelegate;

+(instancetype)getInstance;
+(void)destoryInstance;

/** 获取回放vc**/
-(UIViewController*)getPlayBackVC;
/** 进入回放**/
-(void)enterPlayBackClass:(QXCClassParams*)params;
/** 进入缓存回放**/
-(void)enterCachePlayBackClass:(QXCClassParams*)params;

-(void)enterCachePlayBackClassOnlyAudio:(QXCClassParams*)params;
/** 清理回放**/
-(void)clearPlayBackClass;
/** 如果当前有回放，则清理回放**/
-(void)closeCurPlayBackIfNeed;

/** 设置是否测试环境、线上环境  需要在enterxxxClass之前调用**/
-(void)qxc_setServerType:(QXCServerType)serverType;
/** 设置是否后台播放  需要在enterxxxClass之前调用**/
-(void)qxc_openPlayByBackground:(BOOL) open;
/** 通过客户端设置产品列表  需要在 enterxxxClass之后调用**/
-(void)qxc_setProdcutList:(NSArray<QXCProductModel*>*)productList;


/**是否允许流量播放，true：允许播放 false：不允许会弹出确认窗口  需要在 enterxxxClass之后调用**/
-(void)qxc_allowWWan:(BOOL)allow;

- (void)qxc_isOpenCloudNotes:(BOOL)open;

- (void)qxc_allowCapturedTips:(BOOL)allow;
@end

NS_ASSUME_NONNULL_END
